VERSION 5.00
Begin VB.UserControl XPButton 
   AutoRedraw      =   -1  'True
   ClientHeight    =   405
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1230
   DefaultCancel   =   -1  'True
   Enabled         =   0   'False
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   27
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   82
End
Attribute VB_Name = "XPButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-------------------------------------------------------------------------------------------------
' Module    : ccXPButton
' Updated   : Nov 29 2004
' Author    : Chris Cochran
' Purpose   : My goal with this button is simple: to create a efficient and reliable XPButton
'             that is appropriate for 99% of the apps I write, a single line button without all
'             the overhead of multiple visual styles. I painstakingly tested this control to
'             ensure it never draws twice unessasarily, or freaks when the user doesn't release
'             the mouse button when expected, or when the parent form loses the Windows focus.
'             If all you want is an efficient XP button that works solid, this one may be for you.
'
' Credits   : The subclassing routines included below are the work of Paul Caton.
'
' Web Post  : http://www.planet-source-code.com/vb/scripts/ShowCode.asp?txtCodeId=57148&lngWId=1
'-------------------------------------------------------------------------------------------------
Option Explicit

'//Subclasser declarations
Private Enum eMsgWhen
  MSG_AFTER = 1                                                                         'Message calls back after the original (previous) WndProc
  MSG_BEFORE = 2                                                                        'Message calls back before the original (previous) WndProc
  MSG_BEFORE_AND_AFTER = MSG_AFTER Or MSG_BEFORE                                        'Message calls back before and after the original (previous) WndProc
End Enum
Private Type tSubData                                                                   'Subclass data type
  hWnd                               As Long                                            'Handle of the window being subclassed
  nAddrSub                           As Long                                            'The address of our new WndProc (allocated memory).
  nAddrOrig                          As Long                                            'The address of the pre-existing WndProc
  nMsgCntA                           As Long                                            'Msg after table entry count
  nMsgCntB                           As Long                                            'Msg before table entry count
  aMsgTblA()                         As Long                                            'Msg after table array
  aMsgTblB()                         As Long                                            'Msg Before table array
End Type
Private sc_aSubData()                As tSubData                                        'Subclass data array
Private Const ALL_MESSAGES           As Long = -1                                       'All messages added or deleted
Private Const GMEM_FIXED             As Long = 0                                        'Fixed memory GlobalAlloc flag
Private Const GWL_WNDPROC            As Long = -4                                       'Get/SetWindow offset to the WndProc procedure address
Private Const PATCH_04               As Long = 88                                       'Table B (before) address patch offset
Private Const PATCH_05               As Long = 93                                       'Table B (before) entry count patch offset
Private Const PATCH_08               As Long = 132                                      'Table A (after) address patch offset
Private Const PATCH_09               As Long = 137                                      'Table A (after) entry count patch offset
Private Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function GetModuleHandleA Lib "kernel32" (ByVal lpModuleName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function SetWindowLongA Lib "user32" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

'//Mouse tracking declares
Private Declare Function TrackMouseEvent Lib "user32" (lpEventTrack As TRACKMOUSEEVENT_STRUCT) As Long
Private Enum TRACKMOUSEEVENT_FLAGS
    TME_HOVER = &H1&
    TME_LEAVE = &H2&
    TME_QUERY = &H40000000
    TME_CANCEL = &H80000000
End Enum
Private Type TRACKMOUSEEVENT_STRUCT
    cbSize                              As Long
    dwFlags                             As TRACKMOUSEEVENT_FLAGS
    hwndTrack                           As Long
    dwHoverTime                         As Long
End Type
Private Const WM_MOUSELEAVE             As Long = &H2A3

'//DrawText declares
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Const DT_VCENTER                As Long = &H4
Private Const DT_SINGLELINE             As Long = &H20
Private Const DT_FLAGS                  As Long = DT_VCENTER + DT_SINGLELINE
Private Const DT_CENTER                 As Long = &H1
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

'//Gradient Fill Declares
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Type POINT
   x As Long
   y As Long
End Type
Private Type RGBColor
    r As Single
    G As Single
    B As Single
End Type

'//Misc and multi-use declares
Private Const WM_NCACTIVATE As Long = &H86
Private Const WM_ACTIVATE   As Long = &H6
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function SetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As POINT) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function ClientToScreen Lib "user32" (ByVal hWnd As Long, lpPoint As POINT) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long
Private Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long

'//Button states
Private Enum enumStates
    eDISABLE = 0
    eIDLE = 1
    eFOCUS = 2
    eHOT = 3
    eDOWN = 4
End Enum

Public Enum WindowState
    InActive = 0
    Active = 1
End Enum

'//Button colors
Private Type typeColors
    cBorders(0 To 4)        As Long
    cTopLine1(0 To 4)       As Long
    cTopLine2(0 To 4)       As Long
    cBottomLine1(0 To 4)    As Long
    cBottomLine2(0 To 4)    As Long
    cCornerPixel1(0 To 4)   As Long
    cCornerPixel2(0 To 4)   As Long
    cCornerPixel3(0 To 4)   As Long
    cSideGradTop(1 To 3)    As Long
    cSideGradBottom(1 To 3) As Long
End Type

'//Public Events
Public Event Click()
Public Event DblClick()
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event FormActivate(State As WindowState)

'//Private variables
Private iDownButton         As Integer '------- Down mouse button (for DblClick event)
Private bSkipDrawing        As Boolean '------- Pauses drawing when needed
Private bButtonIsDown       As Boolean '------- Tracks button down state
Private bHasFocus           As Boolean '------- Tracks button focus state
Private bMouseInControl     As Boolean '------- Tracks when mouse is in or out of the button
Private tColors             As typeColors '---- Enum declare for typeColors
Private bParentActive       As Boolean '------- Tracks when parent form has the Windows focus
Private bSpaceBarIsDown     As Boolean '------- Tracks state of spacebar for KeyUp/Down events
Private bMouseButtonIsDown  As Boolean '------- Tracks state of mousebutton for KeyUp/Down events
Private bDisplayAsDefault   As Boolean '------- USed for ambient default property changes
Private lParentHwnd         As Long '---------- Stores the parents window handle
Private eSTATE              As enumStates '---- Enum declare for enumStates

'//Propbag variables
Private pHWND               As Long
Private pCAPTION            As String
Private pENABLED            As Boolean
Private pFORECOLOR          As OLE_COLOR
Private pFOCUSRECT          As Boolean
Private WithEvents pFONT    As StdFont
Attribute pFONT.VB_VarHelpID = -1

Private Sub DrawButton(ByVal State As enumStates)
On Error Resume Next
Dim lw          As Long
Dim lh          As Long
Dim lHdc        As Long
Dim r           As RECT
Dim hRgn        As Long

If bSkipDrawing Then Exit Sub Else eSTATE = State '--------------------- Bolt if desired

With UserControl: lw = .ScaleWidth: lh = .ScaleHeight: .Cls: End With
lHdc = UserControl.hdc

With tColors
    LineApi 3, 0, lw - 3, 0, .cBorders(eSTATE) '------------------------ Draw border lines
    LineApi 0, 3, 0, lh - 3, .cBorders(eSTATE)
    LineApi 3, lh - 1, lw - 3, lh - 1, .cBorders(eSTATE)
    LineApi lw - 1, 3, lw - 1, lh - 3, .cBorders(eSTATE)
    If eSTATE = eDISABLE Or eSTATE = eDOWN Then '----------------------- Fill the back color (DISABLE, DOWN)
        SetRect r, 1, 1, lw - 1, lh - 1
        If eSTATE = eDISABLE Then
            Call DrawFilled(r, 15398133)
        Else
            Call DrawFilled(r, 14607335)
        End If
    Else
        SetRect r, 1, 3, lw - 1, lh - 2 '------------------------------- Draw side gradients
        Call DrawGradient(r, .cSideGradTop(eSTATE), .cSideGradBottom(eSTATE))
        SetRect r, 3, 3, lw - 3, lh - 3 '------------------------------- Draw background gradient (IDLE, HOT, FOCUS)
        Call DrawGradient(r, 16514300, 15133676)
        LineApi 1, 1, lw, 1, .cTopLine1(eSTATE) '----------------------- Draw fade at the top
        LineApi 1, 2, lw, 2, .cTopLine2(eSTATE)
        LineApi 1, lh - 3, lw, lh - 3, .cBottomLine1(eSTATE) '---------- Draw fade at the bottom
        LineApi 2, lh - 2, lw - 1, lh - 2, .cBottomLine2(eSTATE)
    End If
    SetPixel lHdc, 0, 1, .cCornerPixel2(eSTATE) '----------------------- Top left Corner
    SetPixel lHdc, 0, 2, .cCornerPixel1(eSTATE)
    SetPixel lHdc, 1, 0, .cCornerPixel2(eSTATE)
    SetPixel lHdc, 1, 1, .cCornerPixel3(eSTATE)
    SetPixel lHdc, 2, 0, .cCornerPixel1(eSTATE)
    SetPixel lHdc, (lw - 1), 1, .cCornerPixel2(eSTATE) '---------------- Top right corner
    SetPixel lHdc, lw - 1, 2, .cCornerPixel1(eSTATE)
    SetPixel lHdc, lw - 2, 0, .cCornerPixel2(eSTATE)
    SetPixel lHdc, lw - 2, 1, .cCornerPixel3(eSTATE)
    SetPixel lHdc, lw - 3, 0, .cCornerPixel1(eSTATE)
    SetPixel lHdc, 0, lh - 2, .cCornerPixel2(eSTATE) '------------------ Bottom left corner
    SetPixel lHdc, 0, lh - 3, .cCornerPixel1(eSTATE)
    SetPixel lHdc, 1, lh - 1, .cCornerPixel2(eSTATE)
    SetPixel lHdc, 1, lh - 2, .cCornerPixel3(eSTATE)
    SetPixel lHdc, 2, lh - 1, .cCornerPixel1(eSTATE)
    SetPixel lHdc, lw - 1, lh - 2, .cCornerPixel2(eSTATE) '------------- Bottom right corner
    SetPixel lHdc, lw - 1, lh - 3, .cCornerPixel1(eSTATE)
    SetPixel lHdc, lw - 2, lh - 1, .cCornerPixel2(eSTATE)
    SetPixel lHdc, lw - 2, lh - 2, .cCornerPixel3(eSTATE)
    SetPixel lHdc, lw - 3, lh - 1, .cCornerPixel1(eSTATE)
    hRgn = CreateRoundRectRgn(0, 0, lw + 1, lh + 1, 3, 3) '------------- Clip extreme corner pixels
    Call SetWindowRgn(UserControl.hWnd, hRgn, True)
    DeleteObject hRgn
End With
bSkipDrawing = True '--------------------------------------------------- Draw caption
SetRect r, 3, 3, lw - 3, lh - 3
UserControl.ForeColor = IIf(pENABLED, pFORECOLOR, 9609633)
Call DrawText(lHdc, pCAPTION, -1, r, DT_FLAGS + DT_CENTER)
If bHasFocus And pFOCUSRECT And (eSTATE > 1) Then '--------------------- Draw focus rect
    UserControl.ForeColor = 0
    Call DrawFocusRect(lHdc, r)
End If
bSkipDrawing = False

End Sub

Private Sub DrawGradient(r As RECT, ByVal StartColor As Long, ByVal EndColor As Long)
Dim s       As RGBColor '--- Start RGB colors
Dim e       As RGBColor '--- End RBG colors
Dim i       As RGBColor '--- Increment RGB colors
Dim x       As Long
Dim lSteps  As Long
Dim lHdc    As Long
    lHdc = UserControl.hdc
    lSteps = r.Bottom - r.Top
    s.r = (StartColor And &HFF)
    s.G = (StartColor \ &H100) And &HFF
    s.B = (StartColor And &HFF0000) / &H10000
    e.r = (EndColor And &HFF)
    e.G = (EndColor \ &H100) And &HFF
    e.B = (EndColor And &HFF0000) / &H10000
    With i
        .r = (s.r - e.r) / lSteps
        .G = (s.G - e.G) / lSteps
        .B = (s.B - e.B) / lSteps
        For x = 0 To lSteps
            Call LineApi(r.Left, (lSteps - x) + r.Top, r.Right, (lSteps - x) + r.Top, RGB(e.r + (x * .r), e.G + (x * .G), e.B + (x * .B)))
        Next x
    End With
End Sub

Private Sub DrawFilled(tR As RECT, ByVal cBackColor As Long)
Dim hBrush As Long
    hBrush = CreateSolidBrush(cBackColor) '----------------- Fill with solid brush
    FillRect UserControl.hdc, tR, hBrush
    DeleteObject hBrush
End Sub

Private Sub LineApi(ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal Color As Long)
Dim pt      As POINT
Dim hPen    As Long
Dim hPenOld As Long
Dim lHdc    As Long
    lHdc = UserControl.hdc
    hPen = CreatePen(0, 1, Color)
    hPenOld = SelectObject(lHdc, hPen)
    MoveToEx lHdc, X1, Y1, pt
    LineTo lHdc, X2, Y2
    SelectObject lHdc, hPenOld
    DeleteObject hPen
End Sub

Private Sub FillColorScheme()
    With tColors
        .cBorders(0) = 12240841 '--------- Store Disabled Colors
        .cTopLine1(0) = 15726583
        .cTopLine2(0) = 15726583
        .cCornerPixel1(0) = 9220548
        .cCornerPixel2(0) = 12437454
        .cCornerPixel3(0) = 9220548
        .cBorders(1) = 7617536 '---------- Store Idle Colors
        .cTopLine1(1) = 16777215
        .cTopLine2(1) = 16711422
        .cBottomLine1(1) = 14082018
        .cBottomLine2(1) = 12964054
        .cCornerPixel1(1) = 8672545
        .cCornerPixel2(1) = 11376251
        .cCornerPixel3(1) = 10845522
        .cSideGradTop(1) = 16514300
        .cSideGradBottom(1) = 15133676
        .cBorders(2) = 7617536 '---------- Store Focus Colors
        .cTopLine1(2) = 16771022
        .cTopLine2(2) = 16242621
        .cBottomLine1(2) = 15183500
        .cBottomLine2(2) = 15696491
        .cCornerPixel1(2) = 8672545
        .cCornerPixel2(2) = 11376251
        .cCornerPixel3(2) = 10845522
        .cSideGradTop(2) = 16241597
        .cSideGradBottom(2) = 15183500
        .cBorders(3) = 7617536 '---------- Store Hot Colors
        .cTopLine1(3) = 13562879
        .cTopLine2(3) = 9231359
        .cBottomLine1(3) = 3257087
        .cBottomLine2(3) = 38630
        .cCornerPixel1(3) = 8672545
        .cCornerPixel2(3) = 11376251
        .cCornerPixel3(3) = 10845522
        .cSideGradTop(3) = 10280929
        .cSideGradBottom(3) = 3192575
        .cBorders(4) = 7617536 '---------- Store Down Colors.
        .cTopLine1(4) = 14607335
        .cTopLine2(4) = 14607335
        .cBottomLine1(4) = 13289407
        .cCornerPixel1(4) = 8672545
        .cCornerPixel2(4) = 11376251
        .cCornerPixel3(4) = 10845522
    End With
End Sub

Private Function GetAccessKey() As String
'//Extracts and returns the AccessKey appropriate for passed caption
'..Function provided by LiTe Templer (Guenter Wirth)
Dim lPos    As Long
Dim lLen    As Long
Dim lSearch As Long
Dim sChr    As String
    lLen = Len(pCAPTION)
    If lLen = 0 Then Exit Function
    lPos = 1
    Do While lPos + 1 < lLen
        lSearch = InStr(lPos, pCAPTION, "&")
        If lSearch = 0 Or lSearch = lLen Then Exit Do
        sChr = LCase$(Mid$(pCAPTION, lSearch + 1, 1))
        If sChr = "&" Then
            lPos = lSearch + 2
        Else
            GetAccessKey = sChr
            Exit Do
        End If
    Loop
End Function

Private Sub TrackMouseLeave(ByVal lng_hWnd As Long)
On Error GoTo Errs
Dim tme As TRACKMOUSEEVENT_STRUCT
    With tme
        .cbSize = Len(tme)
        .dwFlags = TME_LEAVE
        .hwndTrack = lng_hWnd
    End With
    Call TrackMouseEvent(tme) '---- Track the mouse leaving the indicated window via subclassing
Errs:
End Sub

'Subclass handler - MUST be the first Public routine in this file. That includes public properties also
Public Sub zSubclass_Proc(ByVal bBefore As Boolean, ByRef bHandled As Boolean, ByRef lReturn As Long, ByRef lng_hWnd As Long, ByRef uMsg As Long, ByRef wParam As Long, ByRef lParam As Long)
    Select Case uMsg
        Case WM_MOUSELEAVE
            bMouseInControl = False
            If bSpaceBarIsDown Then Exit Sub
            If eSTATE <> eDISABLE Then
                If bHasFocus Or bDisplayAsDefault Then
                    If eSTATE = eDOWN Then
                        If bButtonIsDown Then
                            Call DrawButton(eFOCUS)
                        Else
                            If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
                        End If
                    Else
                        If eSTATE <> eFOCUS Then
                            If bParentActive Then Call DrawButton(eFOCUS)
                        End If
                    End If
                Else
                    If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
                End If
            End If
            
        Case WM_NCACTIVATE, WM_ACTIVATE
            If wParam Then  '----------------------------------- Activated
                bParentActive = True
                If pENABLED Then
                    If bMouseInControl Then
                        If eSTATE <> eHOT Then Call DrawButton(eHOT)
                    Else
                        If (bHasFocus Or bDisplayAsDefault) Then Call DrawButton(eFOCUS)
                    End If
                End If
                RaiseEvent FormActivate(Active)
            Else            '----------------------------------- Deactivated
                bParentActive = False
                bButtonIsDown = False
                bMouseButtonIsDown = False
                bSpaceBarIsDown = False
                If pENABLED Then If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
                RaiseEvent FormActivate(InActive)
            End If
    End Select
End Sub

Public Sub SnapMouseTo()
On Error Resume Next
Dim pt As POINT
    With UserControl
        '//Get screen coordinates of button
        Call ClientToScreen(.hWnd, pt)
        '//Move mouse to center of button
        Call SetCursorPos(pt.x + .ScaleX(.ScaleWidth / 2, .ScaleMode, vbPixels), _
            pt.y + .ScaleY(.ScaleHeight / 2, .ScaleMode, vbPixels))
    End With
End Sub

Private Sub UserControl_AccessKeyPress(KeyAscii As Integer)
    If pENABLED Then
        If bSpaceBarIsDown Then
            bSpaceBarIsDown = False
            bButtonIsDown = False
            If bMouseInControl Then
                If eSTATE <> eHOT Then Call DrawButton(eHOT)
            Else
                Call DrawButton(eFOCUS)
            End If
        Else
            DoEvents '------------------ Process "GotFocus" before Click event
            RaiseEvent Click
        End If
    End If
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
    bDisplayAsDefault = Ambient.DisplayAsDefault
    If Not pENABLED Or bMouseInControl Then Exit Sub
    If PropertyName = "DisplayAsDefault" Then
        If bDisplayAsDefault Then
            Call DrawButton(eFOCUS)
        Else
            If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
        End If
    End If
End Sub

Private Sub UserControl_Initialize()
    bSkipDrawing = 1
    Call FillColorScheme '-------------- Assign color variables for all states
    Set pFONT = UserControl.Font
    pHWND = UserControl.hWnd
End Sub

Private Sub UserControl_InitProperties()
Dim s   As String
Dim c   As Control
    s = "|" '---------------------------- Try to assume new buttons caption
    For Each c In Parent.Controls       ' This saves me time on most forms :-)
        If TypeOf c Is XPButton Then s = s & c.Caption & "|"
    Next c
    If InStr(1, s, "|&OK|") = 0 Then
        Caption = "&OK"
    ElseIf InStr(1, s, "|&Cancel|") = 0 Then
        Caption = "&Cancel"
    ElseIf InStr(1, s, "|&Apply|") = 0 Then
        Caption = "&Apply"
    Else
        Caption = Extender.Name
    End If
    ForeColor = &H0
    Enabled = True
    FocusRect = True
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = 32 And Not bMouseButtonIsDown Then '---------- Spacebar
        If bMouseInControl Then
            If eSTATE <> eHOT Then Call DrawButton(eHOT)
        Else
            Call DrawButton(eFOCUS)
        End If
        If bButtonIsDown Then RaiseEvent Click
        bSpaceBarIsDown = False
        bButtonIsDown = False
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    With UserControl
        If x > .ScaleWidth Or x < 0 Or y > .ScaleHeight Or y < 0 Then
            bMouseInControl = False
        Else
            bMouseInControl = True
            Call TrackMouseLeave(pHWND)
        End If
    End With
    If Not bParentActive Or bSpaceBarIsDown Then Exit Sub
    If bMouseInControl Then
        If bButtonIsDown Then
            If eSTATE <> eDOWN Then Call DrawButton(eDOWN)
        Else
            If eSTATE <> eHOT Then Call DrawButton(eHOT)
        End If
    Else
        If bHasFocus Then
            If eSTATE <> eFOCUS Then Call DrawButton(eFOCUS)
        Else
            If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
        End If
    End If
    RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    iDownButton = Button '-------- Remember button pressed for DblClick event
    If Button = 1 Then
        bHasFocus = True
        bButtonIsDown = True
        bMouseButtonIsDown = True
        If eSTATE <> eDOWN Then DrawButton (eDOWN)
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 1 Then
        If bParentActive Then
            If bMouseInControl Then
                If eSTATE <> eHOT Then Call DrawButton(eHOT)
            Else
                If bHasFocus Then Call DrawButton(eFOCUS)
            End If
            If bMouseInControl And bHasFocus And bButtonIsDown Then RaiseEvent Click
        End If
        bButtonIsDown = False
        bMouseButtonIsDown = False
    End If
End Sub

Private Sub UserControl_DblClick()
    If iDownButton = 1 Then '------- Only react to left mouse button
        Call DrawButton(eDOWN)
        RaiseEvent DblClick
    End If
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case 13 '------------------- Enter key
            RaiseEvent Click
        Case 37, 38 '--------------- Left Arrow and Up keys
            SendKeys "+{TAB}"
        Case 39, 40 '--------------- Right Arrow and Down keys
            SendKeys "{TAB}"
        Case 32 '------------------- Spacebar
            If Not bMouseButtonIsDown Then
                bSpaceBarIsDown = True
                bButtonIsDown = True
                If eSTATE <> eDOWN Then Call DrawButton(eDOWN)
            End If
    End Select
End Sub

Private Sub UserControl_GotFocus()
    bHasFocus = True
    If bMouseInControl Then
        If eSTATE <> eHOT And eSTATE <> eDOWN Then Call DrawButton(eHOT)
    Else
        If Not bButtonIsDown Then Call DrawButton(eFOCUS)
    End If
End Sub

Private Sub UserControl_LostFocus()
    bHasFocus = False
    bButtonIsDown = False
    bSpaceBarIsDown = False
    If pENABLED Then
        If Not bParentActive Then
            If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
        ElseIf bMouseInControl Then
            If eSTATE <> eHOT Then Call DrawButton(eHOT)
        Else
            If bDisplayAsDefault Then
                Call DrawButton(eFOCUS)
            Else
                If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
            End If
        End If
    End If
End Sub

Private Sub UserControl_Resize()
    With UserControl
        If .Height < 100 Then bSkipDrawing = True: .Height = 100
        If .Width < 100 Then bSkipDrawing = True: .Width = 100
    End With
    If Not bSkipDrawing Then Call DrawButton(eSTATE)
End Sub

Private Sub UserControl_Terminate()
On Error GoTo Errs
    Set pFONT = Nothing
    If Ambient.UserMode Then
        Call Subclass_Stop(pHWND)
        Call Subclass_Stop(lParentHwnd)
    End If
Errs:
End Sub

Public Property Get hWnd() As Long
    hWnd = pHWND
End Property

Public Property Let Caption(ByVal NewValue As String)
    pCAPTION = NewValue
    UserControl.AccessKeys = GetAccessKey '---------- Set AccessKey property if desired
    Call DrawButton(eSTATE)
    UserControl.PropertyChanged "Caption"
End Property

Public Property Get Caption() As String
Attribute Caption.VB_UserMemId = -518
    Caption = pCAPTION
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
    pENABLED = NewValue
    UserControl.Enabled = pENABLED
    bSkipDrawing = 0
    If bMouseInControl And pENABLED Then
        Call DrawButton(eHOT)
    Else
        If bDisplayAsDefault And NewValue Then
            Call DrawButton(eFOCUS)
        Else
            If eSTATE <> Abs(NewValue) Then Call DrawButton(Abs(NewValue))
        End If
    End If
    UserControl.PropertyChanged "Enabled"
End Property

Public Property Get Enabled() As Boolean
    Enabled = pENABLED
End Property

Public Property Get Font() As StdFont
    Set Font = pFONT
End Property

Public Property Set Font(NewValue As StdFont)
    Set pFONT = NewValue
    Call pFONT_FontChanged("")
End Property

Private Sub pFONT_FontChanged(ByVal PropertyName As String)
    Set UserControl.Font = pFONT
    Call DrawButton(eSTATE)
    UserControl.PropertyChanged "Font"
End Sub

Public Property Let ForeColor(NewValue As OLE_COLOR)
    pFORECOLOR = NewValue
    UserControl.ForeColor = pFORECOLOR
    Call DrawButton(eSTATE)
    UserControl.PropertyChanged "ForeColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = pFORECOLOR
End Property

Public Property Let FocusRect(NewValue As Boolean)
Attribute FocusRect.VB_Description = "Displays a rect inside button border when the control has the focus."
    pFOCUSRECT = NewValue
    If bHasFocus Then Call DrawButton(eSTATE)
    UserControl.PropertyChanged "FocusRect"
End Property

Public Property Get FocusRect() As Boolean
    FocusRect = pFOCUSRECT
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    lParentHwnd = UserControl.Parent.hWnd
    With PropBag
        Caption = .ReadProperty("Caption", "&OK")
        ForeColor = .ReadProperty("ForeColor", 0)
        Set Font = .ReadProperty("Font", pFONT)
        FocusRect = .ReadProperty("FocusRect", True)
        Enabled = .ReadProperty("Enabled", True) '--- Keep as last read property for bSkipDrawing variable during initialize
    End With
    If Ambient.UserMode Then
        Call Subclass_Start(pHWND)
        Call Subclass_AddMsg(pHWND, WM_MOUSELEAVE, MSG_AFTER)
        Call Subclass_Start(lParentHwnd)
        If UserControl.Parent.MDIChild Then
            Call Subclass_AddMsg(lParentHwnd, WM_NCACTIVATE, MSG_AFTER)
        Else
            Call Subclass_AddMsg(lParentHwnd, WM_ACTIVATE, MSG_AFTER)
        End If
    End If
    bSkipDrawing = False: Call DrawButton(eSTATE)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "Caption", pCAPTION, "&OK"
        .WriteProperty "Enabled", pENABLED, True
        .WriteProperty "ForeColor", pFORECOLOR, 0
        .WriteProperty "Font", pFONT, "Microsoft Sans Serif"
        .WriteProperty "FocusRect", pFOCUSRECT, True
    End With
End Sub

'========================================================================================
'Start Subclass code - The programmer may call any of the following Subclass_??? routines


'Add a message to the table of those that will invoke a callback. You should Subclass_Start first and then add the messages
Private Sub Subclass_AddMsg(ByVal lng_hWnd As Long, ByVal uMsg As Long, Optional ByVal When As eMsgWhen = MSG_AFTER)
On Error GoTo Errs
'Parameters:
  'lng_hWnd  - The handle of the window for which the uMsg is to be added to the callback table
  'uMsg      - The message number that will invoke a callback. NB Can also be ALL_MESSAGES, ie all messages will callback
  'When      - Whether the msg is to callback before, after or both with respect to the the default (previous) handler
  With sc_aSubData(zIdx(lng_hWnd))
    If When And eMsgWhen.MSG_BEFORE Then
      Call zAddMsg(uMsg, .aMsgTblB, .nMsgCntB, eMsgWhen.MSG_BEFORE, .nAddrSub)
    End If
    If When And eMsgWhen.MSG_AFTER Then
      Call zAddMsg(uMsg, .aMsgTblA, .nMsgCntA, eMsgWhen.MSG_AFTER, .nAddrSub)
    End If
  End With
Errs:
End Sub


'Return whether we're running in the IDE.
Private Function Subclass_InIDE() As Boolean
  Debug.Assert zSetTrue(Subclass_InIDE)
End Function

'Start subclassing the passed window handle
Private Function Subclass_Start(ByVal lng_hWnd As Long) As Long
On Error GoTo Errs
'Parameters:
  'lng_hWnd  - The handle of the window to be subclassed
'Returns;
  'The sc_aSubData() index
  Const CODE_LEN              As Long = 202                                             'Length of the machine code in bytes
  Const FUNC_CWP              As String = "CallWindowProcA"                             'We use CallWindowProc to call the original WndProc
  Const FUNC_EBM              As String = "EbMode"                                      'VBA's EbMode function allows the machine code thunk to know if the IDE has stopped or is on a breakpoint
  Const FUNC_SWL              As String = "SetWindowLongA"                              'SetWindowLongAConst FUNC_S      ,feakp    RaisenButton = cEo'he window tif the IDE has stopped or is on a breakpoint
  Const FU bBsU9-owProc to call tub Tlass,etrol
 cEo'-Dn = cEo'he window tif IDE hindowl hRg      RECT =ScaleWi7As Striogrammer may call any ofH Y1 As Long, ByVal X2 As Long, ByVal Y2 AsA
   0'on = cEo'he window t
    Witsopped o
Ent
    pHWND = UserContr4------  Set pFONT = Nothing
    If on(o callback before, after or both with respect to the  7back before, after or both with respect to the  7back before, afte Lot = 100
        If .Width < 100 Then bSkipDrawing = True: .o the  7back before, afte0
        lafter Nl Enum dec         .ReadPropertButton(Then Call DrawBuN2 Call DrLine Then bSkiR As n_FontChaThen bsSkipDrawing = Tru", = tton(Then Call '  <e
End hWnd  - The hafter Nl Enum dec         .Retton(Then02       tChaThen bsSkipDrawievious) handler
  With sce Then bSke(Subclass_InIer
    SetPixel lHdc, lw - 1, lh - 3, .cCornerPixcnsce Then aultal0ubData(zIdx(lng_hWnd))
    If WLine2(4) = 1460,,i a ption"
End Plt (previous).opertE------------ DraCall DrawBuN2 both wih - 3, .pertyChanged "Caption"
End PropertyontChaThen bsSkipDrawing = Tru" Enum dec     irawButtertyAcs
    If on(o callbawing = Tru" Enum dec  LAUserControl.PropertyChanged "Fhine code thunk 
'Parc As ion"
xton
'             that is appropriate for 99% of d or  '---------------- Top right corner
    SetPixel lHd
Endrs
'Parameters:
mPoint As POINT) As llback bvyChawin,u, ByVal ndo LAUserCoCswin,u, ByVal n------------- Top right corner
 tton = cEo'he window tif the IDE has stopped kmtE------phwBuN2 boroperty "ForeCccccccccccccccc)            Suc(o callback before, after or both with respect to thema======================================
'Start Subclass code - The when parent               hwBuN2ibbzibbzibrure i LAUserCoCsrol.PropertyCha b2.-- Rcccc1,tr{.S      in,u, ByVal nb

Pub===yoive Or bSpaONT = Nott================so.Yhr(1, s lh -zifor 99% of d or  1,truttonB---
    bSrtyrublic Prop% of d he when Irccc)    --  Se========en bSke(Subclass_InIer
    SetPixel lHdc, lw -   Rccall DrawButtonVal ndo LAUserCoCswin,u, ByVal n-9specAUserCoCswin,u, ByVal n-9spe
   l2Eut Ier
    SetPixel lHHHHHHrontro 202         CswinConstub===yoive Or bSpaONT = Nott================so.Yhr(1, s l------- lea)s
Private bSpaceBarIsDown     As Boolean '------- Trive  lHHHHHHrEnd If
End Sub

Private Sub UserControl_0 n,u, ByValb2.-- Rccen mouse is in or out of the button
Private bSpaceBarIsD ------p8 with reIf o
  UserContrIf lSnstupBag====so.Yhr(1, s l------- lea)
  lb2.-- Rccen e'2fore, 3s As Long theTwilb2.-- Rcappropriate for 99% of d or  '--------------HrEnd=so.Yhr(1, s l------- of d ore, 3s As--  Se=== bSpace-- of d orrner
    Setn or out aBawButtonean)
AttribuuseInCon'nt As POINT) As idf   bMoupBag=g theTwilb2st F  0
    --------tno.Y' aBaEnd If
       tribuz  Call DrawButtong = -1                                       'All}c                  'MBong
0
    --------tno.Y' aBaEnd ve Or bSpaONT = OINT/ bMousata(zIdx(pp UserCoaw fade6 ing =,oSubh = 100
    End With
    If Not bSkipDrawing Then Call DraBaEnd IfSubcc----tno.c    nd With
    mrtyChanged "Fore OIN, lpPer may call any of the follhen CallDraBaEnd (S)
   
    End With
    If Not bSkipDrawing Then Call DraBaEnd Ifs-----     As Long = &H2A3

'//DrawTk=I.Y' aB0   .d      FocusRDultal0ubData(zIdx(lnpskipDrawing Then Call D,SPixel2(.  End If
E
    EndDultal0ubData(zIdx(lnpskipDrawing Then Ccnr nd With
 nd Wen bSkiR   skipDrawinSPixeGa s l------- le?            If er'T = OINT/ bo.YhSWith
 nC7 I+------- le?               Call SudkupBag=g theTwilb2st F  0
  assed 4acheopertudkupBag=g theTwidp EndDultal0ubData(zIdkupBpsw fade6 ing =,oS9ps   wn     Ar(1ithEvents pFONT    As StdFont
Attribf41 '--------- St9uvs =dr ing =,oS9ps   wn       'VBA's EbMode function allows tSrIsDown     As Bo---ibf41 '---      'VG
        0
 ue845522
       g Then CffW/ bo.YhE theTr(pHWND)
 with reIf o
  UserContrIf lSnstupBag====so.Yhr(1, s lubData(zIdxW     3(4) =v.Yhr(1Dataaaaaa3ATE)
    UserControl.Propertd .Reption", "upBa9'ixel2(.  End If
E
    EndDultal0n parenteg theTwiddddddddddddddddddddddddddddddddddbuc(o cao a9'ixessed
'Returns;
  'Th"f<w  As LongiskipDraEnd If
ffW;
  'Th"d Iff bDisplayAsDefault Then
            Call DrawButton(eFOCUS)
        Else
            If eSTATE <> eIDLE Then Call DrawButton(eIDLE)
        End STATE <> eIDLEdddd4C7 Iuror GoTo Errs
p2GIertd .Reption", "upBa9'lb, "upBa9Control Th'd 4acheuc(o callllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllllldddddddddddddddddddddThenblA, .nM bo.Yha9Control Th'd 4acheuc(o calllTE)
    End If
    SetPixe 4acheuc(o calllccc Th'd  FUNC_CWP          Fnlassing theu      FocusRDultal0ubD2iNT/rPixel1(eSTATE)
    SetPixel d  - Tv4acheuc(o calllccc TATET)
        Fock2A3

'//DrawTk9nblA, .nM pFsUSEEVENT_STRUCT As Lon? Trusg, .aMsgTblB, .nMsgCntB, eMsgWhen.MSG_BEFORE, .nAdd.nM pFsUSEEVENT_mbientChanged(PropertyNamvs Control_TeEL}own = FaMHHHHH a message to n--- lea)_InIDCT
End Pk--- Set AccessKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKKK=so.Yhr(BEFORE))))))))))))))))eFOCUS)
        Else
            If eSTATE <> eIDLbf eSTATEEDrawBuN2 bothSf d he when Irccc)    --  Se== = 11376251
    Else
            If eSTATE <> eIDLbf eSTATEEDrawBuN2 bothSf d he e/nd Pk--- Se2:e/nd2B SetPixel lHdc, 1, 0, .cCornerPixel2(eSTATE)ps out aBawButtonean)
CessKKP Fnlassing theu      FocusRDu  Caption 3


CessKKP Fnlassing2(eSTATE)ps o4    A8TopLine2(0) = 15726583
        .cCornerPixel1(0)   3


CessKK   Ee, vbPixel DraBaEn

C the messages
Private Sub Subclass_AddMsg(ByVasKKttonean)
en
d vbPixel DraBaEn

C the messages
Private Sub Subclass_AddMsg(ByVa DrawButton(eHOT)
    Else
   2p, .nMccceMsgWheion = "&Cancel"
    ElseIf InStr(1, s, "|&Apply|"TET)
        Fock2A3

'//DrawTk9nblA, .nM pF2(eSTATE)ps o4    A8TopLine2(0)4kSub S If InStr( the messages
PrddiW    b Sub the As S    4.g theu      FocusRDu  Caption 3


Cer S If InStr( the messages
PrddiW    b Sub tixel Dra 1, 1))
        If sChr = "&" Then
            lP2r===============
'Start Subclass code - The prograT)
        Fock2A3

'//DrawTk9nblA, .nM pF2(eSTATE)ps o4    A8TopLine2(0)4kSub S If InStr( the messages
PrddiW    b Sub ttttttttttt     As POINT
Dim ufLbf eSTAlPrddKKKKK2   Ii
Ces   lusg, . eID.Fon4kSub S If InStr( the messagesb S If InSK--- EnuEnum WindowSzapF2(KKKbf eSTAlPrddKKKKK2ic Pro
Dim ufLbf eSTAlP ckMous.i'awButAs RECT, ByVal X1 As .s(f.uEnum WindowSzapF2(KKKbf eSTAlPrddKKKKK2ic Pro
DsTblA2ic Pro    "Se1E)ps o4   pertyNamvs Cont As LongiskipDraEnd If
ffW;
  'Th"d Iff bDisplayAsDefault Th STAlPrddKKKKK2ic Pro
zSetTruet4.g thertyyyyyyyyyyyyyyyyyyyyyys.i'awButAs RECT, BIf eSTATE <> Private SuDm mActivwop% of d he whens POIN
                           9nblA, .nM pF2(eSTATEA3
yRef lPara'lA, .nM pF2(e  g Then CffW/ bo.YhE thelllll          As Long =iKKK2ic PBEFORE))))a4  UserCo:i9byWop% of d heu DraBaEn

C the meeeeeeeeeeeeeeeeeeeee      Caa helHa heeubclass_0rmive Or bucITE <> Private SuDm mActivwop% of d he whens POIN
                     .              Else
           If sChr = "otfdFont
Attribf41 '--------- St9uvs =dr ing =,oS9ps   wn       'VffW/ bo.4ion Subc           Else
           If sChr = "okSub S If InStr( the messagesb S If InSK--- EnuEnum WindowSzapF2(KKKbf eSTAlPrddKKKKK2ic Pro
Dim ufLbf Fect to the  7 the messag8))))a4  UserCo:i9byWop% of d heu Dressagesb S If InSK--- EnuesEnuEnum WindowSzapF2(KKKbf eSTAlPrddKKKKK2ic Pro
sag8))))a4  UserCo:H--- Enus
'ParaTATE        the mAPrddp-            lnM pF2(e  thewop% of d he wraTATE  M pF2(e  g Thhhhhhhhhhh, .nMsgCntB, eMsgWhen.MSG_BEFOR
sag8))))a4  Uswnt = .Renum W ccccccccccccccccccccOco:H--- Emc____ng =,oS9ps   wn   -- El button
PubD2oEPixel d  - Tv4acheuc(o cE       9nb   End With
    If Not bSkipDr = FalseUserCo:i9'n.MSG_BE:H--- EmcuEnum  InSK--- EnuEnum WindowSzATE <> Pr9nb   Rcccc1,tr{.S        .              EeU Hot CDr = False-d ecubD2oEPixelTer S If3.DD2oEPixel d  - Tv4ach       Set pFON b2st F  0
    0, lw, lh -OInSK-y  0, lw, lh -OInSK-y  n lHdc, lw - 1,'e&eGradBot'ddddddddddddddddddd'Tv4ach       SetKKbf eSTAlPrddKKKKK2ic Pro
sag8)utAs RECT,wn Then
hr = "otfdFo   SetPixel lHdc, lw - 1, lhxSub Se-- E = "otfdFE       9nb   ong
Dim lHdc   cont
Attribf41 '--------- St9uvs h, .nMsssssssssss  1, lhxSub Se-- E = "otfdFE       9nb   ong
Dim lHdc   cont
))))))))))))))))))e-- E = "otfdFE
    Set pFFFFFFFFFFFFFFFFFpR.fid, WITE <> Private Salllccc Th'd  FUNC_CWP          Fnlassing theu     e hafter Nl Enum dec         .Ret - 2,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,oooooooooooooooooooon = pCAPTION
End Propertym lHdc   cont
Attribf   .RH"Contros Proper A                   .              Else
          rty "ForeColor", pFORECOLOR,POINT
Diet
Attrib<         rty "Fored .RH"Conk"Conk"Conk"Cenk"I=     rty "rpb   ong
E       9nb    Y1 As tAs R         .              Else
          rImi)ty "FOLOR,POINT
Diet
=     rty "rpb   E,,,oooooooAW;
  'Tx'C5 And Not FFFF8mAct---nms   wl cont,,,,,vC'ball states
    If Not bSkipDrawing Then Call DraBaEnd Ifs-----     tswnt = .ibbzibrure i LAUserCoCsrol.en
        If bParentActive Then
            If bMouseInControl ThfAUserCoCsrol.entf Not bSE6 rentActtF= lubData(zIdxW     3(l.entf N h    Else8DCoCO))a4  Useriehen.Mibf   .RH"Controll Aof bMouseInCsgTbt bSkipD(Tbt bSkiA3
pkDn
           ine1(e
        If bPnnnnnnnnnnnnnnnnnENABPDd_bbDraEnd If
ffW;
  'Th"d Iff bDi While lPos + 1r"d Iff b3rsperty Get ForOINT
BHOT)
    Else
   2p, .nMccceMsgWheion 'balls h    Elb5 .     N     in,u, ByVb.awBuN2,,,,,,,,,,,oodaEnd Ifs--.S      "d IontChaThen bsSkig Then C8W9AongiskipDrion '-(zIdkupBpsw fade6 ing =,ohfAUser-.S    )m A bsSeu8ag8))2h
End Sub

tCO)4acheoper      llback.pDrion '-(zIdkupBpsw fade6 ing =,ohfAUser-.S    )m A bsSeu8ag8)o   mir








































     + 1r"d I alls h    Elb5 .     NB==============Seu8ag8)n Call DrawB===========Seu8ag8)n Call DrawB===========Seu8ag8)n Call DrawB===========Seu8ag8)n Call DrawB=====Sennnnnnnnncheoper  ade6 ing =,ohfAUsbm2Call Draie6 ingd Sub

Private Sub UseAUserth appro,E:H--- Emcu Tv4aDd_bbDraEnd    Call DrawBe  9nb   ong
DimBarIsD -fpFsUS6 ingd Sub























3vate, WMpi/rawity

  As OLE_CO,,,,oo.    RH"Conk"Conk"Conk"Cenk"I=   oddbucn 'balls h    EB===h    Else8DCoCO))a4KK   Ee, vbPixel D       .   sj                               D       . lilse
 tToScreen(sKKP Fnlassing theu      FocusRDu  Caption 3


CessKKP Fnlas .nMsgCntB, eMsgWhen.MSG_BEFORE, .nAdd.nM pFsUSE=PIf
    2Conk"Conk"Conk"Cenk"I,4aDd_b  hWniialse

Envate, WMpi/rawity
t hWniialse

Envate, WMpi/rawity
t hWniialse

Envate, WMpi/rawity
t hWniir And &HFF0000) / &H10000
    e.r = (EndColor And &HFF)A2)o   mir








































     + 1r"d I alls h    FF0000) / rH--- Emc____

Envaten paraPubliI bBut/Dry
t hWe, = 202 rh Drawnnnnnn 1 B's    As Long
DnnnnnnnncheopessKK   Eialse

Envate, WMpi/rawity
t hWniialse

Envate, WMpi/rawity
t hWniir And &HFF0000) / &H10000
    e.r = (EndColor An--------e   e.r = cawButAs RECT, ByVal X1 As .s(B6o4    A8Tnable
Envaten If sChr = "okSuHFF0000)CswinConstub===yoive Or bSpauerPixel3,oodas
t hWe= OINT/ bo.YhSWith
nessKK   v.Yhawity
t h
      .Ret - 2,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,.Yhawityttonb n CapauerPonstub===yyyyyyyyyyyyyyyyywButton(Constub===yoive Or bSpaueTheeb===yoive Or bSl  e.ebSl  unction

-NWokSuHFF000= OINsEbSl  unl DrLq 
2 rh Draapp 8))))a4  UsaueTheeb===yoive Orp  )m A bsSeu8ag8)o   mir




















KKKK2ic Pro
Dim ufLbf Fect to the  7 the mes_kip-----e   e.r = i       v.RgCntB, eMsgWhetAs RECT7i uf     D    PubliI bBut/Dry
t hWe, Envatoo callb,,,,EB,,,,,,,,,,,,.Yhaad  4acheoppthe mes_kip-----e, = "okr), de6 ing =), deo=), deo=), deo=), deo=)ha4  UsaueWniia,,,,saueTthe = "okr), de6 i,pi/ra)ha4'o=), deo=)ha4  Usaue1, s l Aof B}"
g)
 bhwity
t &HFF000"d IfHasF)hWe= OINT/ b00)Cswinoivel X1 As .s(B6opt t pers:
mPoint As ========pnCErr1, s l6dn,LT/ bo.YhS,he = "okwl cont,,,,,vCnM pF2(eSTATE)ps o4 (       .cBruet4.g thertyyyyyyyyyyyyyyyyyyyyyys.i'awButAs pppppppppCd6dn,LT/RS9pWe= OINT/ b00)ate, WMpi/rawity
fS6too callb,,,,EB,,,,,,,,,,,,.YKKKK2ic Pro
saaue1, s l Aof B}"
g)
 bhwity
t &HF meeeeeeeeeeeeeeeeeeeeSr bowB=====Sennn     Pf B}"
g)
 bhwity========Seu8ag8)n Call DrawB===========Seu8alalse
  v.Rg   3(l.entf N 83aueWniiaAs RECT7i uf     D    PubliI bBut/Dry
t hWe, Envatoo ca A8TnCWP                 
g)
k.cCornerPiAV "Conk"C(Dry
t hWe, Subclass_AddMn,u, ByVal nb
)ByVal nbFnlassin0AEs dp En = False
  liI bButddMn,u, ByVal nb
)ByVal nbFB=====Sennn     Pf B}"
g)
L-klbCrmn,u, ByVal nb
)ByVal nbFnlassin0AEs dp En = Fa    
g)
k.cCornerPiAV "Conk"C(Dry
t hWe, Subclass_=KSThen Ccnr nd Wi   (onb no=), deo=)ha4 eo=), 0l9'           
        Case WM_NCACTIVATE, WM_ACT   s   A8Tnathe meeeetddMn,uCase WMlore Disabled C7 the mes_kip-----e   e.r = i  D"Top, Rem programm,,EB, E, WM_ACT   s   018
  v18
  v Or bS2> eHOT aEn

C the messages
Priv messaei1ser-.S    )m At5=yoive  s   018
  ==========Seu8ag8)n Call DrawB=====Sennnnnnnnncheoper  ade6 ing =,ohfAUsbm2Call Draie6 ingd Sub

Private Sub UseAUserth appro,E:H--- Emcu Tv4aDd_bbDraEndVthe meeeetddMn,uCase Wore Dn,u, ByVal nb
)BCB6opt tb.awB RN9 bo.YhS,he = "okwl cont,,,,,vCnM pF2(eSTATEsaei1ser-.S    )m  nn     Pf B}"
g)
 bhwity========Seu8ag8)n Call DrawB===========SeSetPirawB===========SeSetPiraDrawdKKI'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' eMsgWhetAs RECT7i uf     D    PubliI bBut/Dry
t hWe, Envatos,,,,,,,ooooooooooy           B==========UCT
    With tme
        .cbSize = Len(tme)
        .dwFlags = TME_LEAVE
    ooooooooooy
    1        B====2e2(4) = 1460733kr), dI btme
        .cbSize = Len(tme)
        .d)
   aEndVthe meeeetddMn,uCase ine2a









 aEndVthe meeeetddMn,uCase ine2a









 aEndVtWDry
tn = ct tb.awB RN9 bo.YhS,he = "okwl cont,,,,,vCklbCrmn,u, Ba







 aEndVthe meeeetddMn,uCase inet hWe,aEnb===yoiv   Publi{ade61,tr{.S   evu,eBarIsD,u, Ba







 aEn If Not ach       SetKKbf eSTAlPrddKKKKK2ic Pro
sag8)utAs RECE, .nAdd.nM pFsUjnof d he wraTEnvaten If sChhen
,6 "&" Th